package de.tu_darmstadt.tk.shNetSimTests.control;
import java.io.File;

import org.junit.Assert;
import org.junit.Test;

import de.tu_darmstadt.tk.SmartHomeNetworkSim.control.ClassImportException;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.control.ImportController;

/**
 * Tests Import Functionalities of the 
 * 
 *
 * @author Andreas T. Meyer-Berg
 */
public class ClassImportTest {

	String pathToRessources = "src/test/resources/";
    @Test
    public void javaPackageName() {
        Assert.assertNull(ImportController.getJavaPackageName(null));
    }
    
    @Test
    public void javaPackageNameNull(){
    	Assert.assertNull(null);
    }
    
    @Test
    public void javaPackageNameInvalid(){
    	Assert.assertNull(null);
    }
    
    @Test
    public void compileFile(){
    	Class<?> test = null;
    	try {
			test = ImportController.importJavaClass(new File(pathToRessources + "control/testCompilation/project1/MQTT_protocolProject1.java"));
		} catch (ClassImportException e) {
			e.printStackTrace();
		}
    	Assert.assertNotNull(test);
    }
    
    @Test
    public void compileFilePackage(){
    	Class<?> test = null;
    	try {
			test = ImportController.importJavaClass(new File(pathToRessources + "control/testCompilation/packageTest/MQTT_protocolPackageTest.java"));
		} catch (ClassImportException e) {
			e.printStackTrace();
		}
    	Assert.assertNotNull(test);
    }
    
    @Test
    public void compileFileDeepPackage(){
    	Class<?> test = null;
    	try {
			test = ImportController.importJavaClass(new File(pathToRessources + "control/testCompilation/packageTest/deepPackage/reallyDeepPackage/MQTT_protocolDeepPackageTest.java"));
		} catch (ClassImportException e) {
			e.printStackTrace();
		}
    	Assert.assertNotNull(test);
    }
    
    @Test
    public void accessFile(){
    	File f = new File(pathToRessources+"control/testCompilation/project1/MQTT_protocolProject1.java");
    	Assert.assertTrue(f.exists());
    }
	
	public static void main(String[] args) {
		testFileCompilation("testCompilation/project1/MQTT_protocolProject1.java");
		testFileCompilation("testCompilation/packageTest/MQTT_protocolPackageTest.java");
		testFileCompilation("testCompilation/packageTest/deepPackage/reallyDeepPackage/MQTT_protocolDeepPackageTest.java");
	}
	
	private static void testFileCompilation(String pathToFile){
		System.out.println("Test: " + pathToFile);
		try {
			Class<?> c  = ImportController.importJavaClass(new File(pathToFile));
			if(c!=null)
				System.out.println("Import success: "+c.getSimpleName());
			else
				System.out.println("Import null");
		} catch (Exception e) {
			System.out.println("Import failed: "+e.toString());
		}
		System.out.println();
	}
}
